using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using AR;
namespace Project
{
    public partial class FMain
    {

        /// <summary>
        /// 장치의 초기화 여부를 우선 체크 한다.
        /// 장치에 문제가 있는 경우에는 ERROR상황으로 뺀다
        /// ERROR 상황은 RESET 시  IDLE로 전환된다.
        /// 복구불가능한 오류 상황이다.
        /// 
        /// </summary>
        /// <param name="isFirst"></param>
        /// <param name="stepTime"></param>
        /// <returns></returns>
        public Boolean _SM_RUN_STARTCHKHW(bool isFirst, TimeSpan stepTime)
        {
            var mc = PUB.Result.mModel;
            var mv = PUB.Result.vModel;

            //최초시작이므로 - 셔틀2의 안전위치 이동 플래그를 OFF해준다.

            //장치초기화 확인
            if (PUB.mot.IsInit == false || PUB.dio.IsInit == false)
            {
                PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.AZJINIT, eNextStep.ERROR);
                return false;
            }

            //서보 off 상태 확인
            if (PUB.mot.HasServoOff)
            {
                PUB.Result.SetResultMessage(eResult.MOTION, eECode.MOT_SVOFF, eNextStep.ERROR);//, msg);
                return false;
            }

            //홈 검색완료 체크1
            if (PUB.mot.HasHomeSetOff)
            {
                PUB.Result.SetResultMessage(eResult.MOTION, eECode.MOT_HSET, eNextStep.ERROR);
                return false;
            }

            //air확인
            if (DIO.GetIOOutput(eDOName.SOL_AIR) == false)
            {
                PUB.Result.SetResultMessage(eResult.SENSOR, eECode.AIRNOOUT, eNextStep.ERROR);
                return false;
            }

            //카메라초기화체크(초기화가 오래걸려서 쓰레드분리함) - 201229
            if (VAR.BOOL[eVarBool.Opt_DisableCamera] == false && AR.SETTING.Data.Enable_Unloader_QRValidation && PUB.flag.get(eVarBool.FG_RDY_CAMERA_L) == false && AR.SETTING.Data.Disable_Left == false)
            {
                PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.CAM_LEFT, eNextStep.ERROR);
                return false;
            }

            if (VAR.BOOL[eVarBool.Opt_DisableCamera] == false && AR.SETTING.Data.Enable_Unloader_QRValidation && PUB.flag.get(eVarBool.FG_RDY_CAMERA_R) == false && AR.SETTING.Data.Disable_Right == false)
            {
                PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.CAM_RIGHT, eNextStep.ERROR);
                return false;
            }

            //안전위치 센서가 안들어와잇으면 오류 처리한다
            if (DIO.GetIOInput(eDIName.PICKER_SAFE) == false)
            {
                PUB.Result.SetResultMessage(eResult.MOTION, eECode.NEED_JOBCANCEL, eNextStep.ERROR, eAxis.PL_MOVE, PUB.mot.ErrorMessage);
                return false;
            }

            //프린터확인
            if (PUB.flag.get(eVarBool.FG_INIT_PRINTER) == false)
            {
                PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.PRINTER, eNextStep.ERROR);
                return false;
            }

            //부착 실린더 위치 확인
            if (AR.SETTING.Data.Enable_PickerCylinder)
            {
                if (DIO.GetIOInput(eDIName.L_CYLUP) == false)
                {
                    PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.PRINTER_LPRINTER_NOUP, eNextStep.ERROR);
                    return false;
                }
                if (DIO.GetIOInput(eDIName.R_CYLUP) == false)
                {
                    PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.PRINTER_RPRINTER_NOUP, eNextStep.ERROR);
                    return false;
                }
            }

            //부착 실린더 위치 확인
            if (DIO.GetIOInput(eDIName.L_PICK_BW) == false)
            {
                PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.PRINTER_LPICKER_NOBW, eNextStep.ERROR);
                return false;
            }
            if (DIO.GetIOInput(eDIName.R_PICK_BW) == false)
            {
                PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.PRINTER_RPICKER_NOBW, eNextStep.ERROR);
                return false;
            }

            //컨베이어 모드에서 컨베이어에 릴이 감지되면 시작하지 못한다
            if (VAR.BOOL[eVarBool.Use_Conveyor])
            {
                if (DIO.GetIOInput(eDIName.L_CONV1))
                {
                    //감지되면 안된다
                    var ssname = $"X{eDIName.L_CONV1}";
                    PUB.Result.SetResultMessage(eResult.OPERATION, eECode.LCONVER_REEL_DECTECT_ALL, eNextStep.ERROR, ssname);
                    return false;
                }

                if (DIO.GetIOInput(eDIName.R_CONV1) ||
                DIO.GetIOInput(eDIName.R_CONV4))
                {
                    //감지되면 안된다
                    var ssname = $"X{eDIName.R_CONV1}";
                    PUB.Result.SetResultMessage(eResult.OPERATION, eECode.RCONVER_REEL_DECTECT_ALL, eNextStep.ERROR, ssname);
                    return false;
                }
            }

            ////카메라체크
            //for (int i = 0; i < _isCrevisOpen.Length; i++)
            //{
            //	if (COMM.SETTING.Data.DisableCamera(i) == true)
            //	{
            //		PUB.log.AddAT($"카메라({i})번 비활성 됨(환경설정)");
            //	}
            //	else if (_isCrevisOpen[i] == false)
            //	{
            //		if (i == 0 && COMM.SETTING.Data.DisableCamera0 == false && COMM.SETTING.Data.Disable_Left == false)
            //		{
            //			PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.VISION_NOCONN, eNextStep.ERROR, i);
            //			return false;
            //		}
            //		if (i == 2 && COMM.SETTING.Data.DisableCamera2 == false && COMM.SETTING.Data.Disable_Right == false)
            //		{
            //			PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.VISION_NOCONN, eNextStep.ERROR, i);
            //			return false;
            //		}
            //	}
            //}

            //트리거 OFF작업
            WS_Send(eWorkPort.Left, PUB.wsL, "", "OFF", "");
            WS_Send(eWorkPort.Right, PUB.wsR, "", "OFF", "");

            var systembypassmode = SETTING.Data.SystemBypass;

            //바코드설정업데이트
            if (systembypassmode == false)
            {
                bool k1, k2;
                k1 = PUB.MemLoadBarcodeConfig(PUB.keyenceF);
                k2 = PUB.MemLoadBarcodeConfig(PUB.keyenceR);

                if (k1 == false && k2 == false) //결과확인하도록함 230511
                {
                    PUB.Result.SetResultMessage(eResult.HARDWARE, eECode.CONFIG_KEYENCE, eNextStep.ERROR);
                    return false;
                }

            }


            return true;
        }
    }
}
